#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

#define PLUGIN_VERSION	"1.0"

new bool:hintshown[MAXPLAYERS];

public Plugin:myinfo = 
{
	name = "[L4D2] Anti-Drop",
	author = "McFlurry",
	description = "Stops you from firing the last bullet of your m60 and gives you a director hint to find ammo",
	version = PLUGIN_VERSION,
	url = "N/A"
}

public OnPluginStart()
{
	decl String:game_name[64];
	GetGameFolderName(game_name, sizeof(game_name));
	if (!StrEqual(game_name, "left4dead2", false))
	{
		SetFailState("Plugin supports Left 4 Dead 2 only.");
	}
}

public OnMapStart()
{
	for(new i=1;i<=MaxClients;i++) hintshown[i] = false;
}

public OnClientPutInServer(client)
{
    SDKHook(client, SDKHook_WeaponSwitch, OnWeaponSwitch);
}

public Action:OnWeaponSwitch(client, weapon)
{
	decl String:sWeapon[32];
	GetEdictClassname(weapon, sWeapon, sizeof(sWeapon));
	if(StrEqual(sWeapon, "weapon_rifle_m60") && GetEntProp(weapon, Prop_Data, "m_iClip1", 1) == 1)
	{
		ClientCommand(client, "slot2");
		return Plugin_Handled;
	}	
	return Plugin_Continue;
}	

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	new String:wep[40];
	new ent = GetPlayerWeaponSlot(client, 0);
	GetClientWeapon(client, wep, sizeof(wep));
	if(buttons & IN_ATTACK && StrEqual(wep, "weapon_rifle_m60", false) && ent > MaxClients && GetEntProp(ent, Prop_Data, "m_iClip1", 1) == 1)
	{
		buttons &= ~IN_ATTACK;
		GiveHint(client);
		ClientCommand(client, "lastinv");
		return Plugin_Changed;
	}
	return Plugin_Continue;
}	

stock GiveHint(client)
{
	if(IsClientInGame(client) && !IsFakeClient(client) && client > 0 && !hintshown[client])
	{
		decl i_Ent, String:s_TargetName[32], String:s_Message[256], Handle:h_Pack;
		i_Ent = CreateEntityByName("env_instructor_hint");
		FormatEx(s_TargetName, sizeof(s_TargetName), "hint%d", client);
		FormatEx(s_Message, sizeof(s_Message), "Find ammo for your M60!");
		ReplaceString(s_Message, sizeof(s_Message), "\n", " ");
		DispatchKeyValue(client, "targetname", s_TargetName);
		DispatchKeyValue(i_Ent, "hint_target", s_TargetName);
		DispatchKeyValue(i_Ent, "hint_timeout", "5");
		DispatchKeyValue(i_Ent, "hint_range", "0.01");
		DispatchKeyValue(i_Ent, "hint_icon_onscreen", "icon_tip");
		DispatchKeyValue(i_Ent, "hint_caption", s_Message);
		DispatchKeyValue(i_Ent, "hint_color", "255 255 255");
		DispatchSpawn(i_Ent);
		AcceptEntityInput(i_Ent, "ShowHint");
		h_Pack = CreateDataPack();
		WritePackCell(h_Pack, client);
		WritePackCell(h_Pack, i_Ent);
		CreateTimer(5.0, RemoveInstructorHint, h_Pack);
		hintshown[client] = true;
	}
}

public Action:RemoveInstructorHint(Handle:h_Timer, Handle:h_Pack)
{
	decl i_Ent, client;
	ResetPack(h_Pack, false);
	client = ReadPackCell(h_Pack);
	i_Ent = ReadPackCell(h_Pack);
	CloseHandle(h_Pack);
	if (!client || !IsClientInGame(client))
		return Plugin_Handled;
	if (IsValidEntity(i_Ent))
		RemoveEdict(i_Ent);
	return Plugin_Continue;
}